Subject: Re: Retry-After header on 20X response -- HTTP/1.1 spec extension?

From: Mark Nottingham <[email-masked]>
Date: Wed, 15 Apr 2009 17:01:34 +1000

Hi Bryce,

What's the advantage of using Retry-After over Cache-Control here?

Cheers,

On 05/01/2009, at 2:46 PM, Bryce Nesbitt wrote:

> Dear http-wg members.
>
> Where would I go to propose a specification change to HTTP such as  
> the one below (allowing optional Retry-After headers in a 20X  
> response)?  This is a backwards compatible change, and need not have  
> any browser support to be valuable to cooperating automated  
> harvesting robots (e.g. http://www.openarchives.org/OAI/openarchivesprotocol.html 
>  ).
>
> On Mon, Dec 22, 2008 at 8:51 PM, Bryce Nesbitt  
> <[email-masked]> wrote:
> Dear Working Group Folks,
>
> I am not a member of the working group.  But I have recently been  
> tempted to "stretch" the HTTP spec, and I'm writing to inquire if  
> what I'm doing is reasonable enough to eventually fold into the spec.
>
> Basically I'm sending a Retry-After header on a 20x HTTP response.
>
> I'm working with a "throttled" data service which rate limits  
> connections.   Clients are harvesting a huge volumes of data over  
> time.  Presently clients get some data with a 200 result, ask again  
> right away and get a 503 response, then wait out the proper Retry- 
> After time.
>
> If I can return Retry-After with the 20x result, it will cut the  
> total requests in half.  Clients can ask for data, and know  
> immediately how long to wait before they ask again.  Only a client  
> that violates the timeout would ever see a 503.
>
> The HTTP/1.1 spec is pretty clear (in section 14.37) that Retry- 
> After is for 503 and 3xx return codes only. Your thoughts?  Where  
> would I go to suggest an expansion of the Retry-After header, to be  
> inclusive of 20x results?  Is this a reasonable extension in your  
> view?
>

--
Mark Nottingham     http://www.mnot.net/